SOURCES = client.c server.c
SOURCES+= lib/sockets.c
SOURCES+= lib/client-api.c
SOURCES+= lib/connection-handler.c
SOURCES+= flash.c
SOURCES+= lib/hash_table.c

OBJS = $(SOURCES:%.c=%.o)
CC   = gcc
LD   = gcc
CFLAGS =-Wall -Werror -std=gnu99 -I../ -g
LDFLAGS=-lm -pthread
TARGETS = client server flash
.PHONY: all clean

all: $(TARGETS)

$(TARGETS):
	$(LD) $(CFLAGS) $^ -o $@ $(LDFLAGS)

lib/sockets.o: lib/sockets.c lib/sockets.h
lib/hash_table.o: lib/hash_table.c lib/hash_table.h
lib/client-api.o: lib/client-api.c lib/client-api.h
lib/connection-handler.o: lib/connection-handler.c lib/connection-handler.h
server.o: server.c lib/sockets.h lib/server-side-constants.h lib/timer.h lib/errors.h lib/connection-handler.h
client.o: client.c lib/errors.h lib/client-api.h
flash.o: flash.c lib/hash_table.h lib/sockets.h lib/server-side-constants.h lib/errors.h
server:	lib/connection-handler.o lib/sockets.o server.o
client: lib/client-api.o client.o
flash: lib/hash_table.o lib/sockets.o flash.o


%.o:
	$(CC) $(CFLAGS) -c -o $@ $<

clean:
	@echo Cleaning...
	rm -f $(OBJS) $(TARGETS)
	rm -f lib/*.o
